.org 0
.include "2313def.inc"
reset:  rjmp 	CTAPT
int0_:	rjmp 	OTRAB_INT0
int1_:  rjmp 	OTRAB_INT1
tz1:    rjmp 	OTRAB_T1Z
tc11:   rjmp 	OTRAB_TC11

CTAPT:

		ldi R23, 0b000001111
		mov	R16, R23
		lsl R16
		lsl R16
		lsl R16
		andi R16, 0b00111000


        cli
        clr 	R24
        ldi 	R24,	$DF
        out 	SPL,	R24		; 
;------------------[  ]-------------------
        clr 	R24
        out 	GIMSK,	R24
        ldi 	R24, 	0B01000000	;     1
 		out 	TIMSK,	R24
       	ldi 	R24,	0b10000000
        out 	ACSR,	R24			;  
        ldi 	R24,	0b00100010
        out 	MCUCR,	R24
        ldi 	R24,	$40
        out 	GIMSK,	R24
;-------------------------[ ]--------------------------
		ldi 	R24,	$FE
        out 	DDRB,	R24
        ldi 	R24,	$38
        out 	DDRD,	R24
;------------------------[ ]-------------------------
		ldi 	R24, 	$04
		out 	TCCR0, 	R24			;0 = F/256

		clr 	R24
		out 	TCCR1A, R24
		ldi 	R24, 	0B00001101	;1 = F/1024
		out 	TCCR1B, R24
		ldi 	R24, $01			;     196 ms
		out 	OCR1AH, R24
		ldi 	R24, $D0
		out 	OCR1AL, R24
		clr 	R11
		clr 	R10
		ldi 	R24, 0B11000000
		out 	GIFR,R24		;  
		sei
        
	
ZC:		sleep
		mov 	R23, 	R3

TEST:
			
;		mov		R16, 	R23
;		lsl 	R16
;		lsl 	R16
;		lsl 	R16
;		andi 	R16, 	0b00111000
;		out		PORTD,	R16
;		mov		R16, 	R23
;		lsr 	R16
;		lsr 	R16
;		lsr 	R16
;		andi 	R16, 	0b00011111
;		out		PORTB,	R16
;rjmp 	ZC


;R23 - 
		cpi 	R23, 	0b00001100	;  "TV"
		breq 	TV
		cpi 	R23, 	0b00001101	;  "MUTE"
		breq 	MU
		cpi 	R23, 	0b00100110	;  "SLEEP"
		breq 	SL
		cpi 	R23, 	0b00010000	;  "VOL +"
		breq 	VP
		cpi 	R23, 	0b00010001	;  "VOL -"
		breq 	VM
		cpi 	R23, 	0b00100000	;  "CH +"
		breq 	CP
		cpi 	R23, 	0b00100001	;  "CH -"
		breq 	CM
		cpi 	R23, 	0b00000000	;   
		breq 	CL
		rjmp 	ERR					;  -  
	

TV:		sbi 	PORTB, 	7
		rjmp 	ZC
MU:		sbi 	PORTB, 	6
		rjmp 	ZC	
SL:		sbi 	PORTB, 	5
		rjmp 	ZC
VP:		sbi 	PORTB, 	4
		rjmp 	ZC
VM:		sbi 	PORTB, 	3
		rjmp 	ZC
CP:		sbi 	PORTB, 	2
		rjmp 	ZC
CM:		sbi 	PORTB, 	1
		rjmp 	ZC
CL:		clr 	R23
		out		PORTB,	R23
ERR:	rjmp 	ZC




;###################################################################
;###################################################################
;###                                                             ###
;###                                          ###
;###                                                             ###
;###################################################################
;###################################################################
       
OTRAB_INT0:
		clr 	R24
		out 	TCNT0, 	R24
		out 	TCNT1L, R24
		out 	TCNT1H, R24
SEL1:
		in 		R24,	TCNT0
		cpi 	R24,	$12		; 1,1  ?
		brsh 	FAULT_			;   
		sbis 	PIND,	2
		rjmp 	SEL1
		cpi 	R24, 	$4		;    ?
		brlo 	FAULT_		
		rjmp 	IR_INPUT

FAULT_: rjmp FAULT

IR_INPUT:
		
		in 		R22,	TCNT0	;   .
		inc 	R22
		clr 	R24
		out 	TCNT0, 	R24		;    
		mov 	R1,		R22
		lsr 	R22				;/2
		add 	R1, 	R22		; R1 <- 3/2 R22
		mov 	R2, 	R1		
		add 	R2, 	R22		; R2 <- 2*R22

SEL2:	in 		R24,	TCNT0
		cp 		R24,	R1
		brsh 	FAULT
		sbic 	PIND, 	2
		rjmp 	SEL2

		clr 	R24
		out 	TCNT0, 	R24		;    
		clr 	R3				; 
		clr 	R4				; 
		ldi 	R25, 	$0C
		dec 	R1
		dec 	R1
		dec 	R1
		ldi 	R24, 	$04
		add 	R2,		R24
	
TEST_BIT:
		in 		R24,	TCNT0
		cp 		R24, 	R1
		brlo 	TEST_BIT		; 3/2 

		sbic 	PIND, 	2	
		rjmp 	BIT_1			;    "1"

BIT_0:  clc						; 
		rol 	R3
		rol 	R4				; 
	
MB0:	in R24, TCNT0
		cp R24, R2
		brsh FAULT
		sbis PIND, 2
		rjmp MB0
		rjmp NEXT_BIT
	
BIT_1:	sec						; 
		rol R3
		rol R4					; 
	
MB1:	in R24, TCNT0
		cp R24, R2
		brsh FAULT
		sbic PIND, 2
		rjmp MB1
	
NEXT_BIT:
		clr R24
		out TCNT0, R24		;  
		dec R25
		brne TEST_BIT
		reti
	
FAULT:	ldi R24,$FF
		mov R3, R24
		reti        
;------------------------------------------------------------------	
OTRAB_TC11:
	
	clr R3
	clr R10
	reti

OTRAB_INT1:
	reti
OTRAB_T1Z:
	reti
	
